;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Goal point from SMB1. Made by Romi, modified by Ersanio
;Version 1.1
;Uses first extra bit: YES
;Setting the extra bit will trigger the secret exit.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;CUSTOMIZEABLE SPRITE DATA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Sound-related defines
!GoalMusic		= $0C			;Music to play after player is done sliding down the pole
!GlideSound		= $26			;Sound when sliding down. Currently: Firework whistle
!SFXPort		= $1DF9			;SFX Port of the glidesound

;Flagpole flag tiles (SP4)
FlagTileMap:		db $E0,$E2,$E4,$E2

;Flagpole flag tile properties (YXPPCCCT)
FlagTileProperties:	db $2B,$29		;Format: Normal exit,Secret Exit

;I recommend you not to change the following below (until flag 2)

;8x8 tilemap of appearing score tiles (left, right)
ScoreTile:		db $54,$55		;5000
			db $54,$55		;2000
			db $47,$45		;800
			db $46,$45		;400
			db $44,$45		;100

;YXPPCCCT of appearing score tiles (left, right)
ScoreProperty:		db $30|$80,$30|$80	;5000. 2000 upside-down becomes 5000. I'M A GENIUS
			db $30,$30		;2000
			db $30,$30		;800
			db $30,$30		;400
			db $30,$30		;100

ScoreHorz:		db $00,$08		;Relative xpos of score tiles (left, right)

ScoreTable:		dw $01F4,$00C8,$0050,$0028,$000A	;Better if you don't touch this and next table
ScorePosition:		dw $0000,$0010,$0030,$0050,$0078	;5000,2000,800,400,100

!TimeToCreateFlag2	= $20			;\Essential timer values you don't want to mess with
!TimeToWalking		= $E0			;/

;;;;;;;;;;;;;;;;;;;;;;;;;
; Flag 2
;;;;;;;;;;;;;;;;;;;;;;;;;
Flag2TileMap:		db $C0,$C2,$C4,$C6	;Appearing castle flag tilemap (SP4)
!Flag2Property		= $0D			;Properties. YXPPCCCT

!Flag2HorzPos		= $76			;\Don't touch those
Flag2VertPos:		db $20,$80		;/

;;;;;;;;;;;;;;;;;;;;;;;;;
;INIT & MAIN		;
;;;;;;;;;;;;;;;;;;;;;;;;;

			print "INIT ",pc
			LDA $E4,x
			ORA #$08
			STA $E4,x
			RTL

			print "MAIN ",pc
			PHB
			PHK
			PLB
			LDA $7FAB28,x
			LSR A
			BCS ScoreSprite
			BNE ScoreSprite
			JSR SpriteMain
			PLB
			RTL

!ExtraBits = $7FAB10

ScoreSprite:		LSR A
			BCS Flag2Sprite
			JSR ScoreGraphic
			LDA $9D
			BNE ScoreReturn
			LDA $1540,x
			BEQ ScoreReturn
			DEC A
			BNE IncScorePos
			REP #$20
			LDY $C2,x
			LDA ScoreTable,y
			STA $00
			LDA $0DB3
			ASL A
			ADC $0DB3
			AND.w #$00FF
			TAY
			LDA $0F34,y
			CLC
			ADC $00
			STA $0F34,y
			SEP #$20
			LDA $0F36,y
			ADC #$00
			STA $0F36,y
IncScorePos:		LDA $D8,x
			SEC
			SBC #$02
ScoreStoreVPos:		STA $D8,x
			LDA $14D4,x
			SBC #$00
			STA $14D4,x
ScoreReturn:		PLB
			RTL

Flag2Sprite:		JSR Flag2Graphic
			LDA $1540,x
			BEQ ScoreReturn
			LDA $D8,x
			SEC
			SBC #$01
			BRA ScoreStoreVPos

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite Main Routine	;
;;;;;;;;;;;;;;;;;;;;;;;;;

SpriteMain:		JSL START_SUB
			JSR SpriteGraphic

			LDA $1493
			CMP.b #!TimeToCreateFlag2
			BNE NotGenerateFlag2
			JSL $82A9DE
			BMI NotGenerateFlag2
			LDA #$08
			STA $14C8,y
			PHX
			LDA $7FAB9E,x
			TYX
			STA $7FAB9E,x
			JSL $87F7D2
			JSL $8187A7
			LDA #$08
			STA $7FAB10,x
			LDA #$02
			STA $7FAB28,x
			PLX
			LDA $E4,x
			CLC
			ADC #!Flag2HorzPos
			STA $00E4,y
			LDA $14E0,x
			ADC #$00
			STA $14E0,y
			PHY
			LDA $7FAB34,x	;todo
			TAY
			LDA $D8,x
			SEC
			SBC Flag2VertPos,y
			PLY
			AND #$F0
			STA $00D8,y
			LDA $14D4,x
			SBC #$00
			STA $14D4,y
			LDA #$10
			STA $1540,y

NotGenerateFlag2:	LDA $C2,x
			BNE FallingDown
			LDA $9D
			BNE Return
			LDA $D8,x
			SEC
			SBC #$18
			STA $02
			LDA $14D4,x
			SBC #$00
			STA $03
			REP #$20
			LDA $96
			SEC
			SBC $02
			STA $0E
			SEP #$20
			BMI Return
			LDA $E4,x
			STA $00
			LDA $14E0,x
			STA $01
			REP #$20
			LDA $94
			SEC
			SBC $00
			CLC
			ADC.w #$0010
			CMP.w #$0010
			SEP #$20
			BCC TouchesGoalPole
Return:			RTS
TouchesGoalPole:	REP #$20
			LDA $00
			SEC
			SBC.w #$000E
			STA $94
			SEP #$20
			JSR VerticalPosition
			LDA #$80
			STA $1DFB
			LDA.b #!GlideSound
			STA !SFXPort
			INC $C2,x
			JSL $80FA80
			LDA #$48
			STA $1540,x
			LDA $C2,x
FallingDown:		DEC A
			BNE TouchesGround
			LDA #$0B
			STA $71
			LDA #$28	;\freeze time when sliding
			STA $0F30	;/
			LDA #$20
			STA $13E0
			STZ $7B
			STZ $7D
			LDA #$01
			STA $76
			STZ $1407
			STZ $140D
			LDA $77
			AND #$04
			BNE DontIncMarioPos
			REP #$20
			INC $96
			INC $96
			SEP #$20
DontIncMarioPos:	LDA $1540,x
			PHP
			CMP #$0C
			BCC DontIncFlagPos
			LDA $D8,x
			CLC
			ADC #$02
			STA $D8,x
			LDA $14D4,x
			ADC #$00
			STA $14D4,x
DontIncFlagPos:		PLP
			BNE Return
			LDA #$18
			STA $1540,x
			INC $C2,x
			RTS
TouchesGround:		DEC A
			BNE Return
			LDA $1540,x
			BNE RidingYoshiPose
			LDA.b #!TimeToWalking
			STA $1493
			LDA.b #!GoalMusic
			STA $1DFB
			LDA !ExtraBits,x
			AND #$04
			BEQ .NotSecret
			LDA #$01
			STA $141C
.NotSecret		INC $C2,x
			STZ $71
			RTS
RidingYoshiPose:	LDA #$20
			STA $13E0
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;
;SPRITE_GFX		;
;;;;;;;;;;;;;;;;;;;;;;;;;

SpriteGraphic:		JSL GET_DRAW_INFO

			LDA $00
			STA $0300,y
			LDA $01
			STA $0301,y
			PHX
			LDA $14
			LSR A
			LSR A
			LSR A
			AND #$03
			TAX
			LDA FlagTileMap,x
			STA $0302,y
			PLX
			LDA !ExtraBits,x
			AND #$04
			LSR A
			LSR A
			PHX
			TAX
			LDA FlagTileProperties,x
			STA $0303,y
			PLX
			LDY #$02
			LDA #$00
			JSL $81B7B3
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;
;V pos and gen Score	;
;;;;;;;;;;;;;;;;;;;;;;;;;

VerticalPosition:	
			REP #$20
			LDY #$08
			LDA $0E
VertPosLoop:		CMP ScorePosition,y
			BCS VertPosLoopEnd
			DEY
			DEY
			BRA VertPosLoop
VertPosLoopEnd:		STY $03
			SEP #$30

			JSL $82A9DE
			BMI ScoreGenReturn

			LDA #$08
			STA $14C8,y
			PHX
			LDA $7FAB9E,x
			TYX
			STA $7FAB9E,x
			JSL $87F7D2
			JSL $8187A7
			LDA #$88
			STA $7FAB10,x
			LDA #$01
			STA $7FAB28,x
			PLX

			LDA $E4,x
			CLC
			ADC #$08
			STA $00E4,y
			LDA $14E0,x
			ADC #$00
			STA $14E0,y

			LDA $D8,x
			CLC
			ADC #$80
			STA $00D8,y
			LDA $14D4,x
			ADC #$00
			STA $14D4,y

			LDA #$3E
			STA $1540,y
			LDA $03
			STA $00C2,y
ScoreGenReturn:		RTS

;;;;;;;;;;;;;;;;;;;;;;;;;
;Score Graphic		;
;;;;;;;;;;;;;;;;;;;;;;;;;

ScoreGraphic:		JSL GET_DRAW_INFO

			LDA $C2,x
			STA $03

			PHX
			LDX #$01
ScoreGraphicLoop:	PHX
			LDA $01
			STA $0301,y
			LDA $00
			CLC
			ADC ScoreHorz,x
			STA $0300,y
			TXA
			ORA $03
			TAX
			LDA ScoreProperty,x
			STA $0303,y
			LDA ScoreTile,x
			STA $0302,y
			PLX
			INY
			INY
			INY
			INY
			DEX
			BPL ScoreGraphicLoop
			PLX
			LDY #$00
			LDA #$01
GraphicLast:		JSL $81B7B3
			RTS


;;;;;;;;;;;;;;;;;;;;;;;;;

Flag2Graphic:		JSL GET_DRAW_INFO

			LDA $00
			STA $0300,y
			LDA $01
			STA $0301,y
			PHX
			LDA $14
			LSR A
			LSR A
			LSR A
			AND #$03
			TAX
			LDA Flag2TileMap,x
			STA $0302,y
			PLX
			LDA.b #!Flag2Property
			STA $0303,y
			LDA #$00
			LDY #$02
			BRA GraphicLast

;;;;;;;;;;;;;;;;;;;;;;;;;

GET_DRAW_INFO:		STZ $186C,x
			STZ $15A0,x
			LDA $E4,x
			CMP $1A
			LDA $14E0,x
			SBC $1B
			BEQ ON_SCREEN_X
			INC $15A0,x

ON_SCREEN_X:		LDA $14E0,x
			XBA
			LDA $E4,x
			REP #$20
			SEC
			SBC $1A
			CLC
			ADC.w #$0040
			CMP.w #$0180
			SEP #$20
			ROL A
			AND #$01
			STA $15C4,x
			BNE INVALID

			PHB
			PHK
			PLB
			LDY #$00
			LDA $1662,x
			AND #$20
			BEQ ON_SCREEN_LOOP
			INY
ON_SCREEN_LOOP:		LDA $D8,x
			CLC
			ADC SPR_T1,y
			PHP
 			CMP $1C
			ROL $00
			PLP
			LDA $14D4,x
			ADC #$00
			LSR $00
			SBC $1D
			BEQ ON_SCREEN_Y
			LDA $186C,x
			ORA SPR_T2,y
			STA $186C,x
ON_SCREEN_Y:		DEY
			BPL ON_SCREEN_LOOP

			LDY $15EA,x
			LDA $E4,x
			SEC
			SBC $1A
			STA $00
			LDA $D8,x
			SEC
			SBC $1C
			STA $01
			PLB
			RTL

INVALID:		REP #$20
			PLA
			PLY
			PLA
			PHY
			PHA
			SEP #$20
			RTL

SPR_T1:			db $0C,$1C
SPR_T2:			db $01,$02

;;;;;;;;;;;;;;;;;;;;;;;;;

START_SUB:		STZ $03
			PHB
			LDA #$01
			PHA
			PLB
			PEA $801F
			JML $81AC33